#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>

#define MAP_X 32
#define MAP_Y 32
#define BLOCKS_NUM 250

int alls;
int possible;

alls = 0;
possible = 0;

void SetCursorPosition ( int X, int Y )
{
    COORD pos = {X, Y};
    HANDLE output = GetStdHandle(STD_OUTPUT_HANDLE);
    SetConsoleCursorPosition(output, pos);
}

void PrintMap ( int map_tab[MAP_Y][MAP_X] )
{

	// Rysowanie mapy
	/////////////////////////////////////////////////////////////////////////////////////////////////

	int a, b;

	system("cls");


	// Y
	for ( a = 0; a < MAP_Y; a++ )
	{
		// X
		for ( b = 0; b < MAP_X; b++ )
		{

			if 	( map_tab[a][b] == -2 ) printf ( "%c", 177 );
			else if ( map_tab[a][b] == -1 ) printf ( "%c", 254 );
			else if ( map_tab[a][b] ==  0 ) printf ( "M" );
			else printf ( " " );

		}

		printf ( "\n" );

	}

	SetCursorPosition ( 0, MAP_Y+1 );

	printf ( "Mozliwe / Wszystkie ( %d/%d )", possible, alls );

}

int main()
{

	// Zmienne
	////////////////////////////////////////////////////////////////////////

	int a, b, c, d;		   // Pomoc

	int me_x, me_y; 	   // Pozycja ludzika szukajcego celu
	int n_me_x, n_me_y;

	int target_x, target_y;    // Pozycja mety

	int best_way;		   // Najlepszy krok

	int map_tab[MAP_Y][MAP_X]; // Mapa

	srand ( time( NULL ) );

	alls++;

	// Generowanie mapy
	////////////////////////////////////////////////////////////////////////

	me_x = rand()%(MAP_X-2)+1;
	me_y = 0;

	target_x = rand()%MAP_X;
	target_y = MAP_Y-1;

	// Y
	for ( a = 0; a < MAP_Y; a++ )
	{
		// X
		for ( b = 0; b < MAP_X; b++ ) 
		{
		
			if ( a == 0 || a == MAP_Y-1 ) map_tab[a][b] = -3;
			else map_tab[a][b] = -2;
		
		}

	}

	/*
	 *
	 *
	 *	Algorytm tworzenia labityntu wg. metody Sidewinder ( uproszczonej )
	 *
	 * */

	for ( a = 2; a < MAP_Y; a = a+2 )
	{

		for ( b = 1; b < MAP_X-1; b++ )
		{
		
			map_tab[a][b] = -3;

			if ( 60 < rand()%101 )
			{
				c = rand()%5;

				if 	( c == 0 || c == 3 || c == 4 ) map_tab[a-1][b] = -3;
				else if ( c == 1 && b > 0 ) map_tab[a][b-1] = -2;
				else if ( c == 2 && b < MAP_X-1 ) map_tab[a][b+1] = -2, b = b+1;				
			
			}

		}

		Sleep(60);
		PrintMap ( map_tab );


	}

	map_tab[target_y][target_x] = 0;

	// Algorytm cieki
	//////////////////////////////////////////////////////////////////////////////////

	for ( c = 0; c < MAP_Y*MAP_X; c++ )
	{

		for ( a = 0; a < MAP_Y; a++ )
		{

			for ( b = 0; b < MAP_X; b++ )
			{

				if ( map_tab[a][b] >= 0 )
				{

					if ( a - 1 >= 0 )
					{
						if 		      ( map_tab[a-1][b] == -3 ) map_tab[a-1][b] = map_tab[a][b] + 1;
						else if ( map_tab[a-1][b] > map_tab[a][b] + 1 ) map_tab[a-1][b] = map_tab[a][b] + 1;
						else 						map_tab[a-1][b] = map_tab[a-1][b];
					}

					if ( b - 1 >= 0 )
					{
						if 		      ( map_tab[a][b-1] == -3 ) map_tab[a][b-1] = map_tab[a][b] + 1;
						else if ( map_tab[a][b-1] > map_tab[a][b] + 1 ) map_tab[a][b-1] = map_tab[a][b] + 1;
						else 						map_tab[a][b-1] = map_tab[a][b-1];
					}

					if ( a + 1 < MAP_Y )
					{
						if 		      ( map_tab[a+1][b] == -3 ) map_tab[a+1][b] = map_tab[a][b] + 1;
						else if ( map_tab[a+1][b] > map_tab[a][b] + 1 ) map_tab[a+1][b] = map_tab[a][b] + 1;
						else 						map_tab[a+1][b] = map_tab[a+1][b];
					}

					if ( b + 1 < MAP_X )
					{
						if 		      ( map_tab[a][b+1] == -3 ) map_tab[a][b+1] = map_tab[a][b] + 1;
						else if ( map_tab[a][b+1] > map_tab[a][b] + 1 ) map_tab[a][b+1] = map_tab[a][b] + 1;
						else 						map_tab[a][b+1] = map_tab[a][b+1];
					}

				}

			}

		}

	}


	PrintMap ( map_tab );

	SetCursorPosition ( me_x, me_y );

	printf ( "%c", 254 );

	SetCursorPosition ( 0, MAP_Y );


	// Sprawdzenie czy da si przej
	/////////////////////////////////////////////////////////////////////////////////////////////////

	if ( map_tab[me_y+1][me_x] < 0 && map_tab[me_y][me_x+1] < 0 && map_tab[me_y][me_x-1] < 0 ) { printf( "Nie do przejscia" ); Sleep(2000); main(); }


	possible++;

	// Przechodzenie
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	best_way = map_tab[me_y][me_x];
	n_me_x = me_x;
	n_me_y = me_y;

	while ( map_tab[me_y][me_x] != 0 )
	{

		if ( me_x - 1 > -1 && map_tab[me_y][me_x-1] > -1 )
		{
			if ( map_tab[me_y][me_x-1] < best_way ) n_me_x = me_x - 1, best_way = map_tab[me_y][me_x-1];
		}

		if ( me_x + 1 < MAP_X && map_tab[me_y][me_x+1] > -1 )
		{
			if ( map_tab[me_y][me_x+1] < best_way ) n_me_x = me_x + 1, best_way = map_tab[me_y][me_x+1];
		}

		if ( me_y - 1 > -1 && map_tab[me_y-1][me_x] > -1 )
		{
			if ( map_tab[me_y-1][me_x] < best_way ) n_me_y = me_y - 1, best_way = map_tab[me_y-1][me_x];
		}

		if ( me_y + 1 < MAP_Y && map_tab[me_y+1][me_x] > -1 )
		{
			if ( map_tab[me_y+1][me_x] < best_way ) n_me_y = me_y + 1, best_way = map_tab[me_y+1][me_x];
		}

		SetCursorPosition( me_x, me_y );
		printf( "." );

		me_x = n_me_x;
		me_y = n_me_y;

		SetCursorPosition( me_x, me_y );
		printf( "%c", 254 );

		SetCursorPosition( MAP_X+1, MAP_Y+1 );

		Sleep(300);
	}

	Sleep(2000);

	main();

	return 0;
}
